/********************************************************/  
  /* IO. EXP - KEYPAD FUNKCE */
/********************************************************/    
//Setup IO Expanderu
void IOexpander_setup(void) {
/*Cast pro banku A - Tlacitka (7-2) a Rele (1-0)*/    
  //IOCON.BANK = 0
  //GPPU(A) - Pull-Up Resistor Register
    expander.byteWrite(0x0C, 0x00);   //No pullups (na pinech 7..2 jsou externi)
  //GPIO(A) - General Purpose I/O Port
    expander.byteWrite(0x12, 0x03);   //outputy high - DEBUG RELE !!! TBD   //expander.byteWrite(0x12, 0x00);   //All outputs are low   
  //IODIR(A) - I/O Direction Register
    expander.byteWrite(0x00, 0xFC);   //Tlacitka in (7-2) a Rele out (1-0)  //0xFC = 1111 1100
  //INTCON(A) - Interrupt Control
    expander.byteWrite(0x08, 0xFC);   //Interrupt na tlacitkach
  //DEFVAL(A)  - Default Value Comparasion Register for Interrupt on Change
    expander.byteWrite(0x06, 0x00);   //Defaultni hodnoty pro porovnavani - kvuli invertujicimu schmitt triggeru je ve vychozim stavu na vstupu log. 0 i pres pullupy
  //GPINTEN(A) - Interrupt on Change Control
    expander.byteWrite(0x04, 0xFC);   //Interrupt-on-change enable
  //Interrupt pri stisknuti klavesy (detekovan rozdil oproti DEFVAL reg.)
    attachInterrupt(digitalPinToInterrupt(IntButtons), OnBTNPress, FALLING);
/*Cast pro banku B - Keypad*/  
  //IOCON.BANK = 0
  //GPPU(B) - Pull-Up Resistor Register
    expander.byteWrite(0x0D, 0x0F);
  //GPIO(B) - General Purpose I/O Port
    expander.byteWrite(0x13, 0x0F);   
  //IODIR(B) - I/O Direction Register
    expander.byteWrite(0x01, 0x0F);   //Row = Inp. Pullup, Col = Out. LOW
  //INTCON(B) - Interrupt Control
    expander.byteWrite(0x09, 0x0F);   //Interrupt na radcich - porovnavani s DEFVAL registrem
  //DEFVAL(B)  - Default Value Comparasion Register for Interrupt on Change
    expander.byteWrite(0x07, 0x0F);   //Defaultni hodnoty pro porovnavani
  //GPINTEN(B) - Interrupt on Change Control
    expander.byteWrite(0x05, 0x0F);   //Interrupt-on-change enable
  //Interrupt pri stisknuti klavesy (detekovan rozdil oproti DEFVAL reg.)
    attachInterrupt(digitalPinToInterrupt(IntKeypad), OnKeyPress, FALLING);
  return; 
} 
/********************************************************/  
//Interrupt service routine pri stisku klavesnice - zjisti co bylo stisknuto a umisti to do promenne pressed_key
void OnKeyPress(void) {
  //Read INTCAP(B)
    row_read = expander.byteRead(0x11); //ulozeni radku
  /*Rekonfigurace pinu*/
  //IODIR(B) - I/O Direction Register
    expander.byteWrite(0x01, 0xF0);   //Row = Out LOW, Col = Inp. Pullup
  //INTCON(B) - Interrupt Control
    expander.byteWrite(0x09, 0xF0);   //Interrupt na sloupcich - porovnavani s DEFVAL (zde pro vycteni ale neni pouzito)
  //DEFVAL(B)  - Default Value Comparasion Register for Interrupt on Change
    expander.byteWrite(0x07, 0xF0);   //Defaultni hodnoty pro porovnavani
  //GPINTEN(B) - Interrupt on Change Control
    expander.byteWrite(0x05, 0xF0);   //Interrupt-on-change enable
  //Vycteni GPIO(B) 0x13 - Urceni sloupce    
    col_read = expander.byteRead(0x13);
  /*Dekodovani stisknute klavesy*/
    row_konv = 0;
    col_konv = 0;
    konverze(row_read, col_read);     //Zjsteni co za klavesu bylo stisknuto
    pressed_key = klavesy[row_konv][col_konv];  //Ulozeni
    new_key = 1;                                //Flag nove stiskle klavesy
    detachInterrupt(digitalPinToInterrupt(IntKeypad));  //Vypnuti interruptu dokud stale drzim stisklou klavesu
  /*Navraceni pinu do puvodni konfigurace*/
  //IODIR(B) - I/O Direction Register
    expander.byteWrite(0x01, 0x0F);   //Row = Inp. Pullup, Col = Out. LOW
  //INTCON(B) - Interrupt Control -  0x08
    expander.byteWrite(0x09, 0x0F);   //Interrupt na radcich - porovnavani s DEFVAL
  //DEFVAL(B)  - Default Value Comparasion Register for Interrupt on Change  - 0x06
    expander.byteWrite(0x07, 0x0F);   //Defaultni hodnoty pro porovnavani
  //GPINTEN(B) - Interrupt on Change Control - 0x04
    expander.byteWrite(0x05, 0x0F);   //Interrupt-on-change enable
  return;  
}
/********************************************************/  
//Konverze pro dekodovani stiskleho znaku v 'klavesy' arrayi (prevod z hodnoty GPIO portu na znak)
void konverze(uint8_t row, uint8_t col) {           //Konverze uint8_t -> [r][c]
  //Urceni "souradnic" stiskleho znaku na klavesnici
  switch(row){
     case 0x0E: row_konv=0; break;   //1,2,3,A   radek nebo...
     case 0x0D: row_konv=1; break;   //4,5,6,B   radek nebo...
     case 0x0B: row_konv=2; break;   //7,8,9,C   radek nebo...
     case 0x07: row_konv=3; break;   //*,0,#,D   radek
     default: break;
  }
  switch(col){
     case 0x1F: col_konv=0; break;   //1,4,7,*   sloupec nebo...
     case 0x2F: col_konv=1; break;   //2,5,8,0   sloupec nebo...
     case 0x4F: col_konv=2; break;   //3,6,9,#   sloupec nebo...
     case 0x8F: col_konv=3; break;   //A,B,C,D   sloupec
     default: break; 
  }
  return; 
}
/********************************************************/  
/********************************************************/  
  /* IO. EXP - BUTTON FUNKCE */
/********************************************************/
void OnBTNPress(void) {
/*Popis: Pri stisku tlacitka (menu, lock, out...) je vyvolano preruseni, ktere nastavi flag 'new_btnpress',
 *ktery je nasledne zpracovan. Zaroven je odpojen interrupt do te doby, nez je detekovane pusteni tlacitka
 *(to je ale periodicky kontrolovano jinde)*/  
  //Read INTCAP(A)
  pressed_btn = expander.byteRead(0x10);
  detachInterrupt(digitalPinToInterrupt(IntButtons));   //Vypnuti interruptu dokud stale drzim stisklou klavesu  
  //Nutne okamzite a za kazdych okolnosti zpracovat - vypnuti a zapnuti kanalu  
  if(pressed_btn & (1 << 2)) {
    Ch1.output_en = !Ch1.output_en; 
    digitalWrite(CH1_RELAY, Ch1.output_en);           //Zmena stavu kanalu 1
  }
  else if(pressed_btn & (1 << 3)) {
    Ch2.output_en = !Ch2.output_en; 
    digitalWrite(CH2_RELAY, Ch2.output_en);           //Zmena stavu kanalu 2
  }
  else if(pressed_btn & (1 << 4)) {
    if(Ch1.output_en != Ch2.output_en) {              //Zmena stavu kanalu 1 a 2
      Ch1.output_en = 1;                              //Pokud oba kanaly nejsou ve stejnem stavu, uvede je do stejneho stavu
      Ch2.output_en = 1;
    }      
    else {
      Ch1.output_en = !Ch1.output_en; 
      Ch2.output_en = !Ch2.output_en;
    }
    digitalWrite(CH1_RELAY, Ch1.output_en);           //Provedeni zmeny v konfiguraci rele
    digitalWrite(CH2_RELAY, Ch2.output_en);
  }
  new_btnpress = 1;                                     //Nastaveni flagu pro pozdejsi zpracovani
  return;
}
/********************************************************/
