/********************************************************/
  /* VYPSANI NASTAVENYCH HODNOT NAPETI A PROUDU */
/********************************************************/
void redrawLcd(void) {
  lcd.clear();
  //Zobrazeni aktualnich merenych hodnot
  if(show_limits == 0) {                  //Defaultni stav zobrazeni
    //Prvni radek - kanaly a pripadne uzamceni nastaveni
    lcd.setCursor(4, 0);
    lcd.print("Ch1      Ch2");    
    if(value_lock == 1) {
        lcd.setCursor(9,0);
        lcd.write(byte(0));               //Zobrazeni symbolu zamecku
        lcd.noCursor();   
    }
    //Druhy radek - zmerene napeti
    lcd.setCursor(0, 1); lcd.print("U:"); if(Ch1.Vread < 10.0) lcd.print(" "); lcd.print(Ch1.Vread, 2); lcd.print(" V");
    lcd.setCursor(11, 1); lcd.print("U:"); if(Ch2.Vread < 10.0) lcd.print(" "); lcd.print(Ch2.Vread, 2); lcd.print(" V");
    //Treti radek - zmereny proud
    lcd.setCursor(0, 2); lcd.print("I: "); lcd.print(Ch1.Iread, 3); lcd.print("A");
    lcd.setCursor(11, 2); lcd.print("I: "); lcd.print(Ch2.Iread, 3); lcd.print("A");
    //Ctvrty radek - stavovy - rele, upozorneni, debug...
    lcd.setCursor(4,3); if(Ch1.output_en == 1) lcd.print("ZAP"); else lcd.print("VYP");
    lcd.setCursor(13,3); if(Ch2.output_en == 1) lcd.print("ZAP"); else lcd.print("VYP");    
  }//End show_limits = 0
  
  //Zobrazeni aktualnich merenych hodnot a nastavenych limitu 
  else {                                  //Docasny stav zobrazeni
    lcd.setCursor(0, 0);                  //Prvni radek
    lcd.print("U   :"); if(Ch1.Vread < 10.0) lcd.print(" "); lcd.print(Ch1.Vread,2); lcd.print("V   "); if(Ch2.Vset < 10.0) lcd.print(" "); lcd.print(Ch2.Vread,2); lcd.print("V");
    lcd.setCursor(0, 1);                  //Druhy radek
    lcd.print("I   :"); lcd.print(Ch1.Iread,3); lcd.print("A   "); lcd.print(Ch2.Iread,3); lcd.print("A");
    lcd.setCursor(0, 2);                  //Treti radek
    lcd.print("Uset:"); if(Ch1.Vset < 10.0) lcd.print(" "); lcd.print(Ch1.Vset,2); lcd.print("V   "); if(Ch2.Vset < 10.0) lcd.print(" "); lcd.print(Ch2.Vset,2); lcd.print("V");
    lcd.setCursor(0, 3);                  //Ctvrty radek
    lcd.print("Ilim:"); lcd.print(Ch1.Iset,3); lcd.print("A   "); lcd.print(Ch2.Iset,3); lcd.print("A");
  }//End show_limits = 1
  return;
}//End redrawLcd

/********************************************************/
        /* POCATECNI KONFIGURACE LCD DISPLEJE */
/********************************************************/
void lcd_Start_Config(void) {
  lcd.init();
  lcd.backlight();          //Zapnout podsviceni
  redrawLcd();
  lcd.createChar(0, zamek); //Nahrani vlastniho znaku do LCD pameti
  lcd.createChar(1, stupenC);
}
/********************************************************/

/********************************************************/
        /* OBNOVENI HODNOT U,I NA DISPLEJI */
/********************************************************/
void refresh_LCD_values(void) {
  //Zobrazeni aktualnich merenych hodnot
  if(show_limits == 0) {                        //Defaultni stav zobrazeni
    //Aktualizace napeti
    if(LCD_values.Ch1_Vread != Ch1.Vread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(2, 1); lcd.print("     "); 
      if(Ch1.Vread < 10.0) lcd.setCursor(3, 1); else lcd.setCursor(2, 1); lcd.print(Ch1.Vread, 2);
      LCD_values.Ch1_Vread = Ch1.Vread;
    }
    if(LCD_values.Ch2_Vread != Ch2.Vread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(13, 1); lcd.print("     "); 
      if(Ch2.Vread < 10.0) lcd.setCursor(14, 1); else lcd.setCursor(13, 1); lcd.print(Ch2.Vread, 2);
      LCD_values.Ch2_Vread = Ch2.Vread;
    }
    //Aktualizace proudu
    if(LCD_values.Ch1_Iread != Ch1.Iread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(3, 2); lcd.print("     "); lcd.setCursor(3, 2); lcd.print(Ch1.Iread, 3);
      LCD_values.Ch1_Iread = Ch1.Iread;
    }
    if(LCD_values.Ch2_Iread != Ch2.Iread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(14, 2); lcd.print("     "); lcd.setCursor(14, 2); lcd.print(Ch2.Iread, 3);
      LCD_values.Ch2_Iread = Ch2.Iread;
    }
  }
  //Zobrazeni aktualnich merenych hodnot a nastavenych limitu 
  else {                                        //Docasny stav zobrazeni
    //Aktualizace napeti
    if(LCD_values.Ch1_Vread != Ch1.Vread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(5, 0); lcd.print("     "); 
      if(Ch1.Vread < 10.0) lcd.setCursor(6, 0); else lcd.setCursor(5, 0); lcd.print(Ch1.Vread, 2);
      LCD_values.Ch1_Vread = Ch1.Vread; 
    }
    if(LCD_values.Ch2_Vread != Ch2.Vread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(14, 0); lcd.print("     "); 
      if(Ch2.Vread < 10.0) lcd.setCursor(15, 0); else lcd.setCursor(14, 0); lcd.print(Ch2.Vread, 2);
      LCD_values.Ch2_Vread = Ch2.Vread;
    }
    //Aktualizace proudu
    if(LCD_values.Ch1_Iread != Ch1.Iread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(5, 1); lcd.print("     "); lcd.setCursor(5, 1); lcd.print(Ch1.Iread, 3);
      LCD_values.Ch1_Iread = Ch1.Iread;
    }
    if(LCD_values.Ch2_Iread != Ch2.Iread) {     //Hodnota na displeji se zmeni pouze pokud je predchozi zobrazena hodnota odlisna od te soucasne zmerene
      lcd.setCursor(14, 1); lcd.print("     "); lcd.setCursor(14, 1); lcd.print(Ch2.Iread, 3);  
      LCD_values.Ch2_Iread = Ch2.Iread;  
    }
  }
  return;
}//End refresh_LCD_values
/********************************************************/

/********************************************************/
      /* KONTROLA OBVNOVOVACI PERIODY LCD DISPLEJE */
/********************************************************/
void refreshLCD(void) {
  if(currentMillis - lastLCDrefresh >= REFRESH_PERIOD) {
     lastLCDrefresh = currentMillis;
     //ADC_measure_values();              // !!! TEST TBD,
     get_average_values();
     refresh_LCD_values();
     cursor_position();
  }
}//End refreshLCD
/********************************************************/
