/********************************************************/  
  /* ZPRACOVANI VSTUPNIHO STRINGU - NASTAVENI HODNOTY NAPETI NEBO PROUDU */
/********************************************************/    
void setVar(void) {
/* keypad_input_string[20] obsahuje zadany string,
 * var_select urcuje co chci nastavit (1=Ch1.V, 2=Ch1.I, 3=Ch2.V, 4=Ch2.I)
 * a input_len ma informaci o tom, kolik je zadano znaku ve stringu */
  //Kontrola zda string neobsahuje vice desetinnych tecek '*' 
  //(strchr najde pointer na prvni vyskyt, strrchr pointer na posledni vyskyt znaku, melo by fungovat i pokud tam '*' vubec neni)
  if((strchr(keypad_input_string, '.') == strrchr(keypad_input_string, '.')) && input_len >= 1) {
    //Najdi pozici desetinne tecky
    uint8_t decimal_point_pos = 0;                    
    for(int i=0; i<input_len; i++) {
      if(keypad_input_string[i] == '.') {
        decimal_point_pos = i;
        break;
      }
    }
     
    float value = 0;
    switch(decimal_point_pos) {
      case 0:   //Jsou zadany desitky nebo jednotky voltu
        if(keypad_input_string[0] != '.') {
          for(int i=0; i<input_len; i++) {      //[0=desitky]*10^1 + [1=jednotky]*10^0
            value = value + (keypad_input_string[i]-'0')*pow(10,input_len-1-i);      
          }
        }
        break;
      case 1:    //Jsou zadany jednotky voltu a nejspise nejake milivolty (dle delky) - spojeno s nasledujicim case
      case 2: {  //Jsou zadany desitky i jednotky voltu, nejspise i nejake milivolty
        int a = 1;
        for(int i=0; i<input_len; i++) {      //[0=desitky]*10^1 + [1=jednotky]*10^0 + [3=desetiny]*10^-1 + [4]*10^-2...
          if(i == decimal_point_pos) {
            continue;                         //Dalsi iterace for cyklu
          }
          value = value + (keypad_input_string[i]-'0')*pow(10,decimal_point_pos-a);  
          a++;    
        }
        break;
      }
      default:  //Vsechny ostatni pripady - urcite nejsou platne
        break;
    }//end switch
    //Kontrola rozsahu
    if(var_select == 1 || var_select == 3) {        //Vybrano nastavovani napeti - maximalne lze nastavit 20,48 V
      if(value > V_max) {
        value = V_max;
      }
      if(var_select == 1) {                         //Zapis napeti do struktury daneho kanalu
        Ch1.Vset = value;
        DAC_SET(1, 'U', Ch1.Vset/V_per_bit, USE_CALIB); 
      }   
      else {
        Ch2.Vset = value;
        DAC_SET(2, 'U', Ch2.Vset/V_per_bit, USE_CALIB);
      }
    }
    else if(var_select == 2 || var_select == 4) {   //Vybrano nastavovani proudu - maximalne lze nastavit 1,024 A
      if(value > A_max) {
        value = A_max;
      }
      if(var_select == 2) {
        Ch1.Iset = value;                           //Zapis proudu do struktury daneho kanalu
        DAC_SET(1, 'I', Ch1.Iset/A_per_bit, USE_CALIB);
      }
      else {
        Ch2.Iset = value;
        DAC_SET(2, 'I', Ch2.Iset/A_per_bit, USE_CALIB);
      }
    }
  }//end kontrolni if
  redrawLcd();
}//End setVar
/********************************************************/
