/********************************************************/  
  /* ZPRACOVANI STISKLEHO TLACITKA NA KEYPADU */
/********************************************************/   
void keypad_Zpracovani(void) {
  if(value_lock == 0) {
    piezo_beep_x_times(1, SHORT_BEEP_DUR);
    if(pressed_key >= 'A' && pressed_key <= 'D') {  
      keypad_numeric_input_ena = 1;         //Jeste neni vybrano, co se bude nastavovat (nejde davat ciselne vstupy) - povolim
      rot_enc_input_ena = 1;
      change_delitel = 10;                  //Aby mela pripadna zmena rot. enkoderem konzistentni zacatek
      lastKeypadPress = millis();           //Ulozeni timestampu pro timeout
      for(int i = 0; i<7; i++) {            //Inicializace vstupniho stringu
        keypad_input_string[i] = '0';         
      }
      input_len = 0;
      point_pos = 6;
      if(show_limits != 0) {                //Pokud jsem v rezimu zobrazeni nastavenych limitu, navrat do vychoziho stavu...
        show_limits = 0;
        redrawLcd();
      }
      lcd.noCursor();
      lcd.setCursor(0,0);
      lcd.print("                    ");
      lcd.setCursor(3,0);
      switch(pressed_key) {
        case 'A': var_select = 1; 
                  lcd.print("Ch1  U:      V");
                  if(Ch1.Vset < 10) lcd.setCursor(11,0); else lcd.setCursor(10,0); 
                  lcd.print(Ch1.Vset, 2); 
                  break;
        case 'B': var_select = 2; lcd.print("Ch1  I:      A"); lcd.setCursor(11,0); lcd.print(Ch1.Iset, 3); break; 
        case 'C': var_select = 3; 
                  lcd.print("Ch2  U:      V"); 
                  if(Ch2.Vset < 10) lcd.setCursor(11,0); else lcd.setCursor(10,0);
                  lcd.print(Ch2.Vset, 2); 
                  break; 
        case 'D': var_select = 4; lcd.print("Ch2  I:      A"); lcd.setCursor(11,0); lcd.print(Ch2.Iset, 3); break;
        default:  var_select = 0; break;
      }//End switch
      lcd.setCursor(13, 0);
      lcd.cursor();
    }//End if
    else {
      //Jiz je vybrano co se zadava, jsou povoleny vstupy keypadu
      //Zadano cislo nebo desetinna tecka
      if(keypad_numeric_input_ena == 1 && (((pressed_key >= '0' && pressed_key <= '9') || pressed_key == '.') && input_len < 6)) {  
        rot_enc_input_ena = 0;                          //Zadavani na klavesnici znemozni ovladani rot. enc.
        lastKeypadPress = millis();                     //Ulozeni timestampu pro timeout
        if(pressed_key == '.') {                        //Pokud je stisknuta desetinna tecka...
            point_pos = input_len;                      //Ulozi pozici '.', dale mohou byt zadany jen 3 znaky
        }
        keypad_input_string[input_len++] = pressed_key;
        lcd.setCursor(10,0);
        lcd.print("      ");
        for(int i=0; i<input_len; i++) {
          lcd.setCursor(10+i, 0);
          lcd.print(keypad_input_string[i]);
        }
        if(input_len >= 6 || (input_len >= (point_pos+3) && (var_select == 1 || var_select == 3)) || (input_len >= (point_pos+4) && (var_select == 2 || var_select == 4))) {  //Ukonceni - zadan sesty znak nebo druhy/treti znak po desetinne carce
          end_input(PARSE);                             //Ukonceni zadavani, zpracovani stringu
        }
      }
      else if ((keypad_numeric_input_ena == 1 || rot_enc_input_ena == 1) && (pressed_key == '#' || input_len >= 6)) {  //Ukonceni zadavani
        end_input(PARSE);                               //Ukonceni zadavani, zpracovani stringu
      }
      else {
        //Nepovoleny stisk numerickeho tlacitka, nic nedelat, akusticka signalizace
        piezo_beep_x_times(3, BURST_BEEP_DUR);
      }
    }//End else   
  }//End value_lock
  else {                                                //Uprava hodnot U,I je zakazana
    
    for(int i=0; i<2; i++) {                            //Zvukovy signal + probliknuti 'zamecku' na LCD displeji
      if(show_limits != 0) {
        show_limits = 0;
        redrawLcd();
      }
      if(sound_muted != 1) digitalWrite(PiezoPIN, HIGH);
      lcd.setCursor(8,0); lcd.print(">"); lcd.setCursor(10,0); lcd.print("<");
      delay(LONG_BEEP_DUR);
      if(sound_muted != 1) digitalWrite(PiezoPIN, LOW);
      lcd.setCursor(8,0); lcd.print(" "); lcd.setCursor(10,0); lcd.print(" ");
      delay(LONG_BEEP_DUR); 
    }      
  }
}
//////////////////////////////////////////////////////////////////////////////
 
/********************************************************/  
  /* ZPRACOVANI OTACENI A STISKU TLACITKA NA ROTARY ENCODERU */
  /* state_change je vysledek rotary_change_check funkce, state_change = 0 pokud bez zmeny, 1 pokud bylo otoceno clockwise, 2 pokud bylo otoceno counter-clockwise, 3 pokud bylo stisknuto tlacitko */
/********************************************************/ 
void rotary_Zpracovani(int state_change) {
  /* keypad_numeric_input_ena, rot_enc_input_ena */
  //Otoceni rotary encoderu 
  if(state_change > 0 && state_change < 3) {          
    if(rot_enc_input_ena == 1) {                      //Zadavani hodnoty rot. enkoderem je povoleno - upravovani hodnoty U, I
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      keypad_numeric_input_ena = 0;                   //Vypnuti moznosti zadavat keypadem 
      lastRotaryChange = currentMillis;               //Timestamp pro timeout
      float change = 0;
      //Urceni smeru otaceni
      if(state_change == 1) {                         //Otacime clockwise (inkrementace)
        change = 1.0/change_delitel;                  //Pricteni 1V/A*delitel (1, 10, 100)
      }
      else {                                          //Otacime counter-clockwise (dekrementace)
        change = -1.0/change_delitel;                 //Odecteni 1V/A*delitel (1, 10, 100)        
      }
      
      lcd.setCursor(10,0);
      lcd.print("      ");
      
      switch(var_select) {
        case 1:
          lcd.setCursor(11,0);
          if(Ch1.Vset + change >= 0) {
            if(Ch1.Vset + change <= V_max) {
              Ch1.Vset = Ch1.Vset + change;
            }
            else {
              Ch1.Vset = V_max;
            }
            if(Ch1.Vset >= 10) lcd.setCursor(10,0);
          }
          else {
            Ch1.Vset = 0;
          }
          lcd.print(Ch1.Vset, 2);
          DAC_SET(1, 'U', Ch1.Vset/V_per_bit, USE_CALIB); 
          break;
        case 2:
          if(Ch1.Iset + change >= 0) {
            if(Ch1.Iset + change <= A_max) {
              Ch1.Iset = Ch1.Iset + change;
            }
            else {
              Ch1.Iset = A_max;
            }
          }
          else {
            Ch1.Iset = 0;
          }
          lcd.setCursor(11,0);
          lcd.print(Ch1.Iset, 3);
          DAC_SET(1, 'I', Ch1.Iset/A_per_bit, USE_CALIB);
          break;
        case 3:
          lcd.setCursor(11,0);
          if(Ch2.Vset + change >= 0) {
            if(Ch2.Vset + change <= V_max) {
              Ch2.Vset = Ch2.Vset + change;
            }
            else {
              Ch2.Vset = V_max;
            }
            if(Ch2.Vset >= 10) lcd.setCursor(10,0);
          }
          else {
            Ch2.Vset = 0;
          }
          lcd.print(Ch2.Vset, 2);
          DAC_SET(2, 'U', Ch2.Vset/V_per_bit, USE_CALIB); 
          break;
        case 4:
          if(Ch2.Iset + change >= 0) {
            if(Ch2.Iset + change <= A_max) {
              Ch2.Iset = Ch2.Iset + change;
            }
            else {
              Ch2.Iset = A_max;
            }
          }
          else {
            Ch2.Iset = 0;
          }
          lcd.setCursor(11,0);
          lcd.print(Ch2.Iset, 3);
          DAC_SET(2, 'I', Ch2.Iset/A_per_bit, USE_CALIB); 
          break;
      }//End switch
      cursor_position();                    //Presunuti kurzoru do pozice reprezentujiciho upravovanou hodnotu (V, stovky mV, desitky mV...)
    }//End if rotary turn   
  }
  
  //Stisk tlacitka na rot. enkoderu
  else if(state_change == 3) {
    if(rot_enc_input_ena == 1) {            //Povoleno zadavani hodnot rot. enkoderem  - upravovani hodnoty U, I
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      lastKeypadPress = currentMillis;      //Ulozeni timestampu pro timeout
      lastRotaryChange = currentMillis;
      //Zmena velikosti inkrementace/dekrementace rot. encoderem
      switch(change_delitel) {              //10=100mV, 100=10mV, 1=1V zmena pomoci rot. encoderu
        case 10:  change_delitel = 100; break;  
        case 100: change_delitel = 1;   break;  
        case 1:   change_delitel = 10;  break;  
        default:  change_delitel = 10;  break;      
      }
      lcd.setCursor(10,0);
      lcd.print("      ");
      lcd.cursor();
      switch(var_select) {                  //Aktualizace LCD, aby se zmena kurzoru projevila
        case 1:
          if(Ch1.Vset >= 10) lcd.setCursor(10,0);
          else lcd.setCursor(11,0);
          lcd.print(Ch1.Vset, 2);
          break;
        case 2:
          lcd.setCursor(11,0);
          lcd.print(Ch1.Iset, 3);
          break;
        case 3:
          if(Ch2.Vset >= 10) lcd.setCursor(10,0);
          else lcd.setCursor(11,0);
          lcd.print(Ch2.Vset, 2);
          break;
        case 4:
          lcd.setCursor(11,0);
          lcd.print(Ch2.Iset, 3);
          break;
      }//End switch
      cursor_position();                    //Presunuti kurzoru do pozice reprezentujiciho upravovanou hodnotu (V, stovky mV, desitky mV...)              
    }//End zadavani hodnot rot. enkoderem
  }//End if rotary btn press
}
//////////////////////////////////////////////////////////////////////////////

void cursor_position(void) {
  if(rot_enc_input_ena == 1) {
    switch(change_delitel) {                  //Pozice kurzoru ukazuje zda upravuju 1V / 100mV / 10mV
      case 10:  lcd.setCursor(13,0);  break;  //100mV
      case 100: lcd.setCursor(14,0);  break;  //10mV
      case 1:   lcd.setCursor(11,0);  break;  //1V
      default:  lcd.setCursor(13,0);  break;      
    }//End Switch
    lcd.cursor();  
  }
  return;
}

/********************************************************/  
        /* DETEKCE ZMENY STAVU ROTACNIHO ENKODERU*/
/********************************************************/ 
/*Vraci 0 pokud bez zmeny, 1 pokud bylo otoceno clockwise, 2 pokud bylo otoceno counter-clockwise, 3 pokud bylo stisknuto tlacitko*/
int rotary_change_check(void) {
  int result = 0;                                     //Vychozi stav - bez zmeny
  rotA_State  = !(digitalRead(rotA));                 //Cteni stavu rotacniho encoderu, invertovano kvuli invertujicimu Schmitt triggeru
  rotB_State  = !(digitalRead(rotB));
  rotBT_State = !(digitalRead(rotBT));
  if(rotA_State == 0 && rotA_State != rotA_Last) {    //Nastala zmena na pinu A rotary encoderu
    if(rotB_State == 1) {                             //Pokud se nejprve meni signal A [B je stale high] otacime clockwise (inkrementace)
      result = 1;
    }
    else {                                            //Pokud se nejprve zmenil signal B na 0, otacime counter-clockwise (dekrementace)
      result = 2;   
    }
  }
  if(rotBT_State == 0 && rotBT_State != rotBT_Last) { //Bylo stisknuto tlacitko [falling edge detekce]  
    result = 3;
  }
  //Aktualizace po zpracovani
  rotA_Last = rotA_State;
  rotBT_Last = rotBT_State;
  return result;
}
//////////////////////////////////////////////////////////////////////////////

/********************************************************/  
        /* KONTROLA PUSTENI TLACITEK KEYPADU */
/********************************************************/ 
void check_keypad_release(void) {
  if((currentMillis - lastKeypadCheck >= RELEASE_CHECK_PERIOD) && new_key == 0 && pressed_key != 0) {
    lastKeypadCheck = currentMillis;
    dummy = expander.byteRead(0x13);  //Read GPIO(B) 0x13
    if(dummy == 0x0F) {               //Klavesa jiz neni stisknuta, opet pripoj HW interrupt [vsechny klavesy pusteny]
      pressed_key = 0;
      attachInterrupt(digitalPinToInterrupt(IntKeypad), OnKeyPress, FALLING);
    }
  } //End Keypad Check  
  return;
}
//////////////////////////////////////////////////////////////////////////////

/********************************************************/  
      /* KONTROLA TIMEOUTU ZADAVANI KEYPADEM */
/********************************************************/ 
void keypad_timeout_check(void) {
  if((currentMillis - lastKeypadPress >= INPUT_TIMEOUT_PERIOD) && keypad_numeric_input_ena == 1) {
    end_input(NO_PARSE);                        //Ukonceni zadavani  
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////  

/********************************************************/  
     /* KONTROLA TIMEOUTU ZADAVANI ROT. ENKODEREM */
/********************************************************/ 
void rotary_timeout_check(void) {
  if((currentMillis - lastRotaryChange >= INPUT_TIMEOUT_PERIOD) && rot_enc_input_ena == 1 && keypad_numeric_input_ena == 0) {
    end_input(NO_PARSE);                        //Ukonceni zadavani  
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////

/********************************************************/  
    /* UKONCENI ZADAVANI KEYPADEM/ROT. ENKODEREM */
    /* Bool parse_string = 1 pokud se po ukonceni zadavani ma zavolat funkce setVar, ktera zpracuje textovy string na zadane U/I - po zadani keypadem */
/********************************************************/ 
void end_input(uint8_t parse_string) {
  keypad_numeric_input_ena = 0;
  rot_enc_input_ena = 0;
  if(parse_string == PARSE) {
    keypad_input_string[input_len] = '\0';        //Ukonceni stringu
    setVar(); 
  }
  else if(parse_string == NO_PARSE) {
    redrawLcd();
  }
  lcd.noCursor();  
  return;
}
//////////////////////////////////////////////////////////////////////////////
