/********************************************************/  
  /* VICEUROVNOVA NABIDKA MENU */
/********************************************************/ 
bool menu_scroll = 1;                         //Flag scrollovani v menu pro aktualizaci LCD

void enterMenu_lvl1(uint8_t menu_choice_begin) {
    /*Promenne pro menu*/
  const uint8_t menu_uplim = 4;               //Useful do budoucna pokud by byly vice nez 4 polozky menu
  const uint8_t menu_downlim = 0;
  uint8_t menu_up_bound = 3; 
  uint8_t menu_down_bound = 0; 
  if(!(menu_choice_begin >= menu_down_bound && menu_choice_begin <= menu_up_bound)) { //Hlidani rozsahu
    return;  
  }
  uint8_t menu_choice = menu_choice_begin;    //Na cem je aktualne najety kurzor
  menu_scroll = 1;
  lcd.clear();
  
  /*Nekonecna Menu smycka*/
  while(1) {                                              //Nekonecna smycka Menu nabidky
    currentMillis = millis();
    
    /*LCD - pohyb v menu*/
    if(menu_scroll == 1) {                                //Doslo k posunuti v menu, prekresli, zmen pozici kurzoru
      menu_scroll = 0;
      for(int i=0; i<4; i++) {
        lcd.setCursor(0,i);
        switch(i+menu_down_bound) {
          case 0: lcd.print("1: FAN SPEED  ");  break;    //Uprava rychlosti vetraku, PWM rizeny, 0-255                      
          case 1: lcd.print("2: CALIBRATION");  break;    //Kalibrace napeti - nasteveno vs namereno
          case 2: lcd.print("3: TEMPERATURE");  break;    //Zobrazeni aktualni teploty             
          case 3: lcd.print("4: SOUND      ");  break;    //Aktivace/umlceni zvukove signalizace
          case 4: lcd.print("5: PC COMM    ");  break;    //Aktivaci/deaktivace seriove komunikace s PC (FTDI - USB)
          default: break;
        }            
      }
      lcd.setCursor(0, menu_choice-menu_down_bound);      //Kurzor ukazujici soucasnou volbu polozky
      lcd.cursor();                                       //Kurzor ukazuje na jake polozce v menu jsme
    }//End Menu Scroll
    
        /* Stisk nejakeho tlacitka pokud jsem v menu, kontrola zda se jedna o tlacitko Menu */
    if(new_btnpress == 1) {
      new_btnpress = 0;
      if(pressed_btn & (1 << 6)) {              //Bitmask, divam se na bit 6, zajima me kdy je stisknuto tlacitko Menu (-> opusteni menu) - detekce log.1
          piezo_beep_x_times(1, SHORT_BEEP_DUR);
          lcd.noCursor();
          redrawLcd();
          return;                               //Opusteni nabidky Menu 
      }     
    }

    /* Tlacitka - snaha o clearnuti interruptu [jen do uspesneho clearu] */
    check_btn_release();

    //Rotacni enkoder - kontrola stavu
    int rot_output = rotary_change_check();
    //Pohyb v menu otacenim
    if(rot_output > 0 && rot_output < 3) {
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      if(rot_output == 1) {                   //Otacime clockwise (inkrementace)
        if(menu_choice < menu_up_bound)
          menu_choice++;
        else if(menu_up_bound < menu_uplim) { //Scroll dolu
          menu_choice++;
          menu_up_bound++;
          menu_down_bound++;
        }
        else 
          menu_choice = menu_uplim;           //Jsme na hornim limitu, dale neinkrementuj (a kdyby nahodou tak vrat na limit) 
      }
      else {                                  //Otacime counter-clockwise (dekrementace)
        if(menu_choice > menu_down_bound)
          menu_choice--;                      //Scroll nahoru
        else if(menu_down_bound > menu_downlim) {
            menu_choice--;
            menu_up_bound--;
            menu_down_bound--;
        }
        else
          menu_choice = menu_downlim;   //Jsme na dolnim limitu, dale nedekrementuj (a kdyby nahodou tak vrat na limit)                                                                                 
      }
      menu_scroll = 1;                    //Flag scrollovani v menu pro aktualizaci LCD
    }//End rotary turn check
      /*Rotary Encoder detekce stisku = enter */
    else if(rot_output == 3) {
      //Stisk tlacitka na rotary encoderu je Enter - vstup do dalsi urovne menu
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      rotBT_Last = 0;                     //Zabezpeci ze v dalsi urovni hned neni vyvolan zdanlivy novy stisk tlacitka
      enterMenu_lvl2(menu_choice);
    }//End RotBT check
    check_CLIM(); 
  }//End While
  return;
}

/********************************************************/
void enterMenu_lvl2(uint8_t menu_choice_begin) {
  lcd.noCursor();
  switch(menu_choice_begin) {
    case 0:
      UserFanSetting();
      break;
    case 1:
      CalibrationSetting();
      break;
    case 2: 
      TemperatureSetting();
      break;
    case 3:
      SoundSetting(); 
      break;
    case 4:
      PC_CommSetting(); 
      break;
    default: break;
  }
  lcd.cursor();
  lcd.clear();
  menu_scroll = 1;                      //Po navratu se prekresli nabidka menu
  return;
}  

/********************************************************/
  /* RYCHLOST VETRAKU */
void UserFanSetting(void) {
/* Nastaveni rychlosti vetraku pomoci PWM - hodnoty 0-255 odpovidaji vystupnimu napeti priblizne 1,25 - 12V */
  lcd.clear();  
  lcd.setCursor(0,0);
  lcd.print("Fan Speed");
  bool fan_changed = 1;
  int rot_output = 0;
  while(1) {
    rot_output = rotary_change_check();
    if(rot_output > 0 && rot_output < 3) {
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      if(rot_output == 1) {                         //Otacime clockwise (inkrementace)
        if(USER_FAN_SPEED < 255)
          USER_FAN_SPEED++;
        else                                        //Jsme na hornim limitu, dale neinkrementuj (a kdyby nahodou tak vrat na limit)
          USER_FAN_SPEED = 255;
      }
      else {                                        //Otacime counter-clockwise (dekrementace)
        if(USER_FAN_SPEED > 0)
          USER_FAN_SPEED--;
        else                                        //Jsme na dolnim limitu, dale nedekrementuj (a kdyby nahodou tak vrat na limit)
          USER_FAN_SPEED = 0;                                                     
      }
      fan_changed = 1;                              //Flag scrollovani v menu pro aktualizaci LCD
    }//End RotA check
    if(rot_output == 3) {
      //Stisk tlacitka na rotary encoderu je Enter - vstup do dalsi urovne menu
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      rotBT_Last = 0;                               //Zabezpeci ze v dalsi urovni hned neni vyvolan zdanlivy novy stisk tlacitka
      EEPROM.update(FAN_CFG_ADDR, USER_FAN_SPEED);  //Aktualizace hodnoty v EEPROM (pri shode se nezapisuje)
      if(EEPROM.read(FAN_CFG_ADDR) != USER_FAN_SPEED)
        EEPROM.write(FAN_CFG_ADDR, USER_FAN_SPEED); //Kontrola...
      break;
    }//End RotBT check

      /* LCD zobrazeni */
    if(fan_changed == 1) {
      fan_changed = 0;
      setFans(); 
      lcd.clear();
      lcd.setCursor(0,1);
      lcd.print("User:   ");
      lcd.print(USER_FAN_SPEED);
      lcd.setCursor(0,2); 
      lcd.print("Actual: ");
      lcd.print(FAN_SPEED); 
    }
    check_CLIM(); 
  }// End while
  return;
}
/********************************************************/

/********************************************************/  
  /* VYCTENI A ZOBRAZENI TEPLOT ZE SENZORU DS18B20 */
/********************************************************/ 
void TemperatureSetting(void) {
  lcd.clear();
  //Kontrola jestli nedoslo k odpojeni senzoru
  for(int i=0; i<4; i++) {
    lcd.setCursor(0,i);
    switch(i) {
      case 0: lcd.print("Teploty ["); lcd.write(byte(1)); ; lcd.print("C]"); break;                         
      case 1: lcd.print("Senzor 1: ");  break;
      case 2: lcd.print("Senzor 2: ");  break;             
      case 3: lcd.print("Senzor 3: ");  break;
      default: break;
    }            
  }
  unsigned long last_check_Millis = 0;
  int rot_output = 0;
  while(1) {                                                  //Nekonecna smycka do opetovneho stisku rotBTN
    currentMillis = millis();
    if(currentMillis - last_check_Millis >= 1000) {
      last_check_Millis = currentMillis;
      get_temperatures();
      for(int i=0; i<3; i++){
        if(temperatures[i] != DEVICE_DISCONNECTED_C) {        //Senzor odpojen - vytiskni "ERR"     
          lcd.setCursor(11,i+1); lcd.print(temperatures[i],1);
        }
        else {
          lcd.setCursor(11,i+1); lcd.print("ERR");
        }
      }
      setFans();                                              //Zmereni teploty -> uprav rychlost vetraku
    }
    //Kontrola stisku RotBTN
    rot_output = rotary_change_check();                       //Stisk rotBTN = navrat
    if(rot_output == 3) {
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      break;
    }
    check_CLIM();                                             //Kontrola proudove limitace
  }//End While
  return;                                                     //Navrat do Menu
}//End Temperature
/********************************************************/

/********************************************************/  
  /* AKTIVACE/DEAKTIVACE ZVUKOVE SIGNALIZACE */
/********************************************************/
void SoundSetting(void) {
//Poznamka: pro ulehceni volat v kodu funkci "piezo_beep_x_times", ktera ma toto ztlumovani implementovane
  sound_muted = !sound_muted;                     //Toggle nastaveni zvuku
  EEPROM.update(SOUND_CFG_ADDR, sound_muted);     //Aktualizace hodnoty v EEPROM (pri shode se nezapisuje)
  if(EEPROM.read(SOUND_CFG_ADDR) != sound_muted)
    EEPROM.write(SOUND_CFG_ADDR, sound_muted);    //Kontrola...
  lcd.clear();
  lcd.setCursor(0,0); lcd.print("Nastaveni zvuku");
  lcd.setCursor(0,1); 
  if(sound_muted == 0) lcd.print("Zvuk zapnut"); 
  else                 lcd.print("Zvuk vypnut"); 
  piezo_beep_x_times(1, SHORT_BEEP_DUR);
  delay(3000);                                    //Dostatek casu na precteni zmeny stavu na displeji      
  return;
}//End SoundSetting
/********************************************************/

/********************************************************/  
                    /* KALIBRACE */
/********************************************************/
void CalibrationSetting(void) {
    //Kalibrace DAC+zesilovace - nastaveni kodu, zmereni napeti multimetrem, dostaveni do presne hodnoty
  Serial.println("- - - DAC CALIB BEGIN - - -");
  Ch1.output_en = 1;                                          //Pripojeni na vystupni svorky
  Ch2.output_en = 1;
  digitalWrite(CH1_RELAY, Ch1.output_en);           
  digitalWrite(CH2_RELAY, Ch2.output_en);
  for(int kanal=1; kanal<3; kanal++){
    int DACval = 20;
    int rot_output = 0;
    int DA_prev_calib = 0;
    for(int kod=0; kod<3200; kod=kod+100){
      if(kod == 0) {                                          //Omezeni minimalnim nastavitelnym napetim
        kod = 20;
      }
      DA_prev_calib = DA_kompenzace(kanal, 'U', kod);
      DACval = DA_prev_calib;
      lcd.clear();
      lcd.setCursor(0,0); lcd.print("Dostav na CH"); lcd.print(kanal); lcd.print(" UOUT");
      lcd.setCursor(0,1); lcd.print("Cil:  "); lcd.print(kod*V_per_bit, 2); lcd.print(" V");
      DAC_SET(kanal, 'U', DACval, NO_CALIB); 
      lcd.setCursor(0,2); lcd.print("Kod:  "); lcd.print(DACval);
      while(1){
        rot_output = rotary_change_check();                   //Stisk rotBTN = pokracovani, otacenim ikrementace/dekrementace po jednotkach
        if(rot_output > 0 && rot_output < 3) {          
          //Urceni smeru otaceni
          if(rot_output == 1) {                               //Otacime clockwise (inkrementace)
            if(DACval+1 <= 4095)
              DACval = DACval+1;                  
          }
          else {                                              //Otacime counter-clockwise (dekrementace)
            if(DACval-1 >= 0)
              DACval = DACval-1;                     
          }
          lcd.setCursor(6,2); lcd.print("      ");
          lcd.setCursor(6,2); lcd.print(DACval);
          DAC_SET(kanal, 'U', DACval, NO_CALIB); 
        }
        if(rot_output == 3) {
          piezo_beep_x_times(1, SHORT_BEEP_DUR);
          int delta = kod-DACval;
          DAC_u_calib_table[kanal-1][kod/100] = delta;        //Rovnou se naplni kalibracni tabulka aby mohla byt vyuzita u kalibrace DAC
          if(delta<0) delta = abs(delta)+100;
          if(kanal == 1) {
            EEPROM.update(DAC_U_CH1_CALIB_START_ADDR+(kod/100), delta);
            Serial.print("Saved DAC1: "); Serial.println(delta);
          }
          else {
            EEPROM.update(DAC_U_CH2_CALIB_START_ADDR+(kod/100), delta);
            Serial.print("Saved DAC2: "); Serial.println(delta);
          }
          break;
        }
      }//End while
      if(kod == 20) {                                         //Omezeni minimalnim nastavitelnym napetim
        kod = 0;
      } 
    }//End for kod
  }//End for kanal
  Serial.println("- - - DAC CALIB END - - -");
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //Kalibrace Uout (DAC je referencni, doladuji aby ADC cetlo stejnou hodnotu)
    //Nulovani Iout pri odpojene zatezi (odstranuje vliv zateze na vystupu potrebne pro dosazeni 0Vout)
  Serial.println("- - - ADC CALIB BEGIN - - -");
  Ch1.output_en = 0;                                      //Odpojeni externi zateze
  Ch2.output_en = 0;
  digitalWrite(CH1_RELAY, Ch1.output_en);           
  digitalWrite(CH2_RELAY, Ch2.output_en);
  DAC_SET(1, 'U', 0, USE_CALIB);                          //Jiz vyuziva kalibrovany DAC - nastaveni nuly, casova rezerva na vybiti kapacity
  DAC_SET(2, 'U', 0, USE_CALIB); 
  delay(5000);
  int DACval = 20;
  int ADC_U1 = 0;
  int ADC_I1 = 0;
  int ADC_U2 = 0;
  int ADC_I2 = 0;
  int delta_U1 = 0;
  int delta_U2 = 0;
  uint8_t index = 0;                                      //Pozice ukladani do pameti EEPROM vuci zacatku definovanem konstantou U_CHx_CALIB_START_ADDR
  while(1){
    Serial.print("DACval: "); Serial.println(DACval);
    DAC_SET(1, 'U', DACval, USE_CALIB);                   //Jiz vyuziva kalibrovany DAC
    DAC_SET(2, 'U', DACval, USE_CALIB);          
    lcd.clear();
    lcd.setCursor(0,0); lcd.print("    U1  I1   U2  I2");
    lcd.setCursor(0,1); lcd.print("DA:"); lcd.print(DACval); lcd.setCursor(12,1); lcd.print(DACval);
    lcd.setCursor(0,2); lcd.print("AD:");
    delay(2000);                                          //Delay pro ustaleni hodnoty
    int temp_arr[4] = {0};
    for(int i=0; i<10; i++) {                             //10 vzorku, prumerovani
      temp_arr[0] += ADC_transfer(CS_ADC1, 'U');
      temp_arr[1] += ADC_transfer(CS_ADC1, 'I');
      delay(10);
      temp_arr[2] += ADC_transfer(CS_ADC2, 'U');
      temp_arr[3] += ADC_transfer(CS_ADC2, 'I');
      delay(10);
    }
    ADC_U1 = temp_arr[0]/10;
    ADC_I1 = temp_arr[1]/10;
    ADC_U2 = temp_arr[2]/10;
    ADC_I2 = temp_arr[3]/10;
    lcd.setCursor(3,2); lcd.print(ADC_U1);  Serial.print("ADC U1: "); Serial.print(ADC_U1); Serial.print("  ");
    lcd.setCursor(8,2); lcd.print(ADC_I1);  Serial.print("ADC I1: "); Serial.print(ADC_I1); Serial.print("  ");
    lcd.setCursor(12,2); lcd.print(ADC_U2); Serial.print("ADC U2: "); Serial.print(ADC_U2); Serial.print("  ");
    lcd.setCursor(17,2); lcd.print(ADC_I2); Serial.print("ADC I2: "); Serial.println(ADC_I2); 
    delta_U1 = ADC_U1-DACval;                             //DACval je brana jako korektni referencni hodnota
    delta_U2 = ADC_U2-DACval;                             //DACval je brana jako korektni referencni hodnota
    lcd.setCursor(0,3); lcd.print("DEL:");
    lcd.setCursor(4,3); lcd.print(delta_U1);  Serial.print("delta U1: "); Serial.print(delta_U1); Serial.print("  ");
    lcd.setCursor(13,3); lcd.print(delta_U2); Serial.print("delta U2: "); Serial.println(delta_U2);
    if(delta_U1<0) delta_U1 = abs(delta_U1)+100;          //Hodnoty nad 100 jsou zaporna cisla (do EEPROM lze ulozit uint8_t
    if(delta_U2<0) delta_U2 = abs(delta_U2)+100;          //Hodnoty nad 100 jsou zaporna cisla (do EEPROM lze ulozit uint8_t
    EEPROM.update(U_CH1_CALIB_START_ADDR+index, delta_U1);  Serial.print("Saved U1: "); Serial.print(delta_U1); Serial.print("  ");
    EEPROM.update(I_CH1_CALIB_START_ADDR+index, ADC_I1);    Serial.print("Saved I1: "); Serial.print(ADC_I1);   Serial.print("  ");
    EEPROM.update(U_CH2_CALIB_START_ADDR+index, delta_U2);  Serial.print("Saved U2: "); Serial.print(delta_U2); Serial.print("  ");
    EEPROM.update(I_CH2_CALIB_START_ADDR+index, ADC_I2);    Serial.print("Saved I2: "); Serial.println(ADC_I2);
    delay(2000);
    index++;
    if(DACval == 20) {
      DACval = 100;
    }
    else if(DACval<(V_max/V_per_bit)+100) {               //Sweep od 200 mV do 31 V (code 3100)
      DACval = DACval+100;
    }
    else {                                                //DACval = 3100, sweep dokoncen
      break;
    }
  }
  Serial.println("- - - ADC CALIB END - - -");
  
  //test vycitani EEPROM                                  //DEBUG
  Serial.println("- - - EEPROM READ BEGIN - - -");
  for(int i=U_CH1_CALIB_START_ADDR; i<DAC_U_CH2_CALIB_END_ADDR+1; i++) {
    int temp = EEPROM.read(i);
    lcd.clear();
    lcd.setCursor(0,0); lcd.print("Index "); lcd.print(i);
    if(i>=U_CH1_CALIB_START_ADDR && i<U_CH2_CALIB_START_ADDR)               {lcd.print("   U1"); if(temp >= 100) temp = 100-temp; Serial.print("kalibrace U1: "); Serial.println(temp);}
    else if(i>=U_CH2_CALIB_START_ADDR && i<I_CH1_CALIB_START_ADDR)          {lcd.print("   U2"); if(temp >= 100) temp = 100-temp; Serial.print("kalibrace U2: "); Serial.println(temp);}
    else if(i>=I_CH1_CALIB_START_ADDR && i<I_CH2_CALIB_START_ADDR)          {lcd.print("   I1"); Serial.print("kalibrace I1: "); Serial.println(temp);}
    else if(i>=I_CH2_CALIB_START_ADDR && i<DAC_U_CH1_CALIB_START_ADDR)      {lcd.print("   I2"); Serial.print("kalibrace I2: "); Serial.println(temp);}
    else if(i>=DAC_U_CH1_CALIB_START_ADDR && i<DAC_U_CH2_CALIB_START_ADDR)  {lcd.print("   DAC U1"); if(temp >= 100) temp = 100-temp; Serial.print("kalibrace DAC1: "); Serial.println(temp);}
    else if(i>=DAC_U_CH2_CALIB_START_ADDR)                                  {lcd.print("   DAC U2"); if(temp >= 100) temp = 100-temp; Serial.print("kalibrace DAC2: "); Serial.println(temp);}
    lcd.setCursor(0,1); lcd.print(temp);
    delay(500);
  }
  Serial.println("- - - EEPROM READ END - - -");    
  return;
}//End Calibration
/********************************************************/

/********************************************************/  
                 /* PC KOMUNIKACE */
/********************************************************/
void PC_CommSetting(void) {
  int rot_output = 0;
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Printing TEST");
  while(1) {
    check_CLIM(); 
    Serial.println("TEST");   
    rot_output = rotary_change_check();                   //Stisk rotBTN = navrat
    if(rot_output == 3) {
      piezo_beep_x_times(1, SHORT_BEEP_DUR);
      break;
    } 
    delay(500);
  }
  return; 
}
/********************************************************/
