//////////////////////////////////////////////////////////////////////////////
//Piezo x-nasobne pipnuti
/*x = pocet pipnuti, bp_duration = delka pipnuti v milisekundach*/
void piezo_beep_x_times(int x, int bp_duration) {
  if(sound_muted == 1)  
    return;
  for(int i=0; i<x; i++) {
    digitalWrite(PiezoPIN, HIGH);
    delay(bp_duration);
    digitalWrite(PiezoPIN, LOW);
    if(x > 1) delay(bp_duration);
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
//Kontrola signalu proudove limitace
void check_CLIM(void) {
  //Ochrana proti tvrdemu zkratu vystupu - odpojeni vystupu (0 Ohm na vystupu - protoze zdroj neumi jit do zcela nuloveho Uout, je jakekoliv napeti pres 0 Ohmu -> 1A; proto dojde radeji k odpojeni vystupu)
  if(Ch1.CLIM != 1 && (Ch1.Vread < 0.5 && Ch1.Iread >= 1)) {
    Ch1.output_en = 0; 
    digitalWrite(CH1_RELAY, Ch1.output_en);           //Odpojeni kanalu
    redrawLcd();
  }
  if(Ch2.CLIM != 1 && (Ch2.Vread < 0.5 && Ch2.Iread >= 1)) {
    Ch2.output_en = 0; 
    digitalWrite(CH2_RELAY, Ch2.output_en);           //Odpojeni kanalu
    redrawLcd();
  }
  //Signalizace CLIM bzucakem
  if(currentMillis - lastCLIMCheck >= CLIM_CHECK_PERIOD) {
    lastCLIMCheck = currentMillis; 
    Ch1.CLIM = digitalRead(CH1_CLIM);
    Ch2.CLIM = digitalRead(CH2_CLIM); 
    if((Ch1.CLIM != 1 || Ch2.CLIM != 1) && CLIM_signalized == 10) {            //Proudova limitace aktivni - upozorni pipnutim pokud je zapnuty zvuk
      piezo_beep_x_times(2, LONG_BEEP_DUR-50); 
      CLIM_signalized = 0; 
    }
    else if(!(Ch1.CLIM != 1 || Ch2.CLIM != 1) && CLIM_signalized < 10){        //K resetu nedojde hned, proti pipani pri kazdem pulsiku
      CLIM_signalized++;
    }
  }
  return;
}
//////////////////////////////////////////////////////////////////////////////
